#include <hmg.ch>

STATIC nSeconds := 0
STATIC nMinutes := 0

*--------------------------------------*
FUNCTION MAIN  
*--------------------------------------*

SET CODEPAGE TO UNICODE
SET LANGUAGE TO SPANISH
SET DATE FRENCH
SET CENTURY ON
SET ESCAPE ON
SET DATE FORMAT "dd/mm/yyyy"
SET EPOCH TO YEAR(DATE())-50
*--------------------------------------*

  PUBLIC cName := ''
  PUBLIC nCursRow := 0
  PUBLIC nCursCol := 0
  PUBLIC cadena1, cadena2, eXida1, eXida2
  PRIVATE nRecords

  PRIVATE QbColorx := {|| IF( ordkeyno()/2 == INT(ordkeyno()/2) , ORANGE , { 183,245,205 } ) }           
  PRIVATE QfColorx := {|| IF( ordkeyno()/2 == INT(ordkeyno()/2) , { 000,000,255 },{ 000,000,255 } ) } 

*------------------------------------------------------------------------------------------------------*
 
  IF !File("DateTime1.dbf")
           DateTime_1()
  ENDIF 
  IF !File("DateTime2.dbf")
           DateTime_2()
  ENDIF 

  IF !IsWindowDefined("Form_1")    

          DEFINE WINDOW Form_1               ;
		AT 0, 0                      ;
		WIDTH 940 HEIGHT 630         ;
                ICON 'Logo'                  ; 
		TITLE ""                     ; 
                BACKCOLOR { 246,225,214}     ; 
                MAIN NOSIZE NOMAXIMIZE       ;
                ON MOUSEDRAG MueveControl()  ;
                ON MOUSEMOVE  Mouse_Position()

                ON KEY ESCAPE ACTION ( SalExit() , Form_1.Release )  

         @ 012,120 LABEL Label_55 VALUE "Ajedrez-Chess Game" AUTOSIZE ;
                   FONT "Arial" SIZE 23 BOLD ITALIC ;
                   FONTCOLOR BLACK TRANSPARENT
         @ 010,119 LABEL Label_56 VALUE "Ajedrez-Chess Game" AUTOSIZE ;
                   FONT "Arial" SIZE 23 BOLD ITALIC ;
                   FONTCOLOR {255,255,000}  TRANSPARENT   

         @ 055,020 IMAGE Tablisky PICTURE "Resource\Tablero.jpg" WIDTH 500 HEIGHT 500 STRETCH 
         SetProperty( "Form_1","Tablisky", "Enabled", .F.)

*----------------------------------------------------------------------------------------------*
        Fichas()   //   _Fichas.prg <------------- Fichas Ajedrez - Chess
*----------------------------------------------------------------------------------------------*

         @ 065,640 LABEL Label_57 VALUE "Chronometer" AUTOSIZE ;
                   FONT "Arial" SIZE 20 BOLD ITALIC ;
                   FONTCOLOR BLACK TRANSPARENT
         @ 063,639 LABEL Label_58 VALUE "Chronometer" AUTOSIZE ;
                   FONT "Arial" SIZE 20 BOLD ITALIC ;
                   FONTCOLOR {255,255,000}  TRANSPARENT   

        @ 103,604 LABEL Label_08aQ VALUE "" WIDTH 242 HEIGHT 100 ;   
                 FONT "Ms Sans Serif" SIZE 0011 BORDER CLIENTEDGE BACKCOLOR {128,126,255} 

        SetProperty( "Form_1","Label_08aQ", "Enabled", .F.)

        @ 111, 634 LABEL Label_70 VALUE "Blancas" AUTOSIZE FONT "Arial" SIZE 14  BACKCOLOR {128,126,255} FONTCOLOR {255,255,255} 
        @ 111, 754 LABEL Label_71 VALUE "Negras"  AUTOSIZE FONT "Arial" SIZE 14  BACKCOLOR {128,126,255} 

	@ 140, 624 LABEL Label_Time1 VALUE "00:00" AUTOSIZE FONT "Arial" SIZE 25 BACKCOLOR {128,126,255}
        @ 140, 744 LABEL Label_Time2 VALUE "00:00" AUTOSIZE FONT "Arial" SIZE 25 BACKCOLOR {128,126,255} 

        DEFINE TIMER Timer_0 INTERVAL 1000 ACTION ;    
             ( Form_1.TITLE := SPACE(06) + "Ajedrez-Chess Game" + SPACE(03) + "v.0.1 " + SPACE(04)+" Fecha: " + DTOC(DATE()) + ;
                          SPACE(04) + "Hora: " + TIME() )                         
                          RELEASE MEMORY

	DEFINE TIMER Timer_1 ;
		INTERVAL 1000 ;
		ACTION ( UpdateTimer1())  

        DEFINE TIMER Timer_2 ;
		INTERVAL 1000 ;
		ACTION ( UpdateTimer2() ) 

*------------------------------------------------------------- Start-Stop ------------------------------------------------------------------*
        @ 221,630 BUTTON Button_1  PICTURE "Resource\Go1.jpg"    WIDTH  037  HEIGHT 037  TOOLTIP "Start" ACTION ( Horax1() ,StartTimer1() ) 
        @ 221,670 BUTTON Button_2  PICTURE "Resource\Stop1.jpg"  WIDTH  037  HEIGHT 037  TOOLTIP "Stop"  ACTION StopTimer1()  

        @ 221,750 BUTTON Button_3  PICTURE "Resource\Go1.jpg"    WIDTH  037  HEIGHT 037  TOOLTIP "Start" ACTION ( Horax2() ,StartTimer2() ) 
        @ 221,790 BUTTON Button_4  PICTURE "Resource\Stop1.jpg"  WIDTH  037  HEIGHT 037  TOOLTIP "Stop"  ACTION  StopTimer2()     
*--------------------------------------------------------------------------------------------------------------------------------------------*

     DBCLOSEALL()
     SELECT 1
     USE DateTime1 
     DBGoBottom() 

     DEFINE BROWSE  xBrowse_1
             PARENT Form_1
             ROW    284 
             COL    585
             WIDTH  135
             HEIGHT 183 
             WIDTHS  { 043,043,043 }                 
             HEADERS { "Start","End","Total" } 
             WORKAREA DateTime1  
             FIELDS {"RIGHT( DateTime1->Hora_E,5)","RIGHT(DateTime1->Hora_S,5)","RIGHT(DateTime1->Hora_T,5)" }
             ALLOWEDIT .F.
             VSCROLLBAR .F.
             HSCROLLBAR .F.
             JUSTIFY { 2,2,2 }
             TOOLTIP ""
             DYNAMICBACKCOLOR { QbColorX,QbColorX ,QbColorX}  
             DYNAMICFORECOLOR { QfColorx,QfColorX ,QfColorX}  
             BACKCOLOR { 180,200,255 }
             FONTCOLOR { 000,255,020 } 
      END BROWSE

      DBCLOSEALL() 
      SELECT 2
      USE DateTime2 
      DBGoBottom() 

      DEFINE BROWSE  xBrowse_2
             PARENT Form_1
             ROW    284 
             COL    728
             WIDTH  135
             HEIGHT 183 
             WIDTHS  { 043,043,043 }                 
             HEADERS { "Start","End","Total" } 
             WORKAREA DateTime2  
             FIELDS {"RIGHT( DateTime2->Hora_E,5)","RIGHT(DateTime2->Hora_S,5)","RIGHT(DateTime2->Hora_T,5)" }
             ALLOWEDIT .F.
             VSCROLLBAR .F.
             HSCROLLBAR .F.
             JUSTIFY { 2,2,2 }
             TOOLTIP ""
             DYNAMICBACKCOLOR { QbColorX,QbColorX ,QbColorX}  
             DYNAMICFORECOLOR { QfColorx,QfColorX ,QfColorX}  
             BACKCOLOR { 180,200,255 }
             FONTCOLOR { 000,255,020 } 
      END BROWSE

*--------------------------------------------------------------------------------------------------------------------------------------*
   @ 489, 585 LABEL Label_TOT1 VALUE "Blancas Total:" WIDTH 300 HEIGHT 020 AUTOSIZE FONT "Arial" SIZE 10 BOLD BACKCOLOR { 246,225,214}  
   @ 489, 730 LABEL Label_TOT2 VALUE "Negras Total:"  WIDTH 300 HEIGHT 020 AUTOSIZE FONT "Arial" SIZE 10 BOLD BACKCOLOR { 246,225,214} 
*--------------------------------------------------------------------------------------------------------------------------------------*
 *--------------------------------------------------------------------------------------------------------------------------------------*
   @ 519,690 IMAGE Basex_2  PICTURE "Resource\Cancel.jpg"     WIDTH  035  HEIGHT 035 STRETCH TOOLTIP "Erase Bases"  ACTION SalExit() 
   @ 519,730 IMAGE Basex_3  PICTURE "Resource\Exit.jpg"       WIDTH  035  HEIGHT 035 STRETCH TOOLTIP "Exit"         ACTION Form_1.Release 
*--------------------------------------------------------------------------------------------------------------------------------------*
 	
   DEFINE STATUSBAR
      STATUSITEM ""  WIDTH 600     
      STATUSITEM ""  WIDTH 100
      STATUSITEM ""  WIDTH 100
   END STATUSBAR

  END WINDOW

      SetProperty( "Form_1","Button_3", "Enabled", .F.)
      SetProperty( "Form_1","Button_4", "Enabled", .F.)

      SetProperty( "Form_1","Timer_1", "Enabled", .F.)
      SetProperty( "Form_1","Timer_2", "Enabled", .F.)

      HMG_ChangeWindowStyle( GetControlHandle( "Tablisky" , "Form_1" ) , LVS_REPORT, NIL, .T. )
      HMG_ChangeWindowStyle( GetControlHandle( "xBrowse_1", "Form_1" ) , LVS_REPORT, NIL, .T. )
      HMG_ChangeWindowStyle( GetControlHandle( "xBrowse_2", "Form_1" ) , LVS_REPORT, NIL, .T. )

      SETWINDOWCURSOR( Form_1.Button_1.Handle, "Resource\SmoothHand.cur" )
      SETWINDOWCURSOR( Form_1.Label_01.Handle, "Resource\SmoothHand.cur" )

   CENTER WINDOW Form_1
   ACTIVATE WINDOW Form_1

   ELSE

        DoMethod ("Form_1","Restore")
     
   ENDIF

RETURN Nil

*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*


*---------------------------------------------*
FUNCTION Mouse_Position()
*---------------------------------------------*
  Form_1.StatusBar.Item( 2 ) := "Row : " + LTRIM( STR( _HMG_SYSDATA [ 191 ] )) // Mouse Row
  Form_1.StatusBar.Item( 3 ) := "Col : " + LTRIM( STR( _HMG_SYSDATA [ 192 ] )) // Mouse Col
RETURN

*---------------------------------------------*
PROCEDURE MueveControl()
*---------------------------------------------*

* https://www.hmgforum.com/viewtopic.php?p=33619&hilit=arrastrar+y+soltar#p33619
*  Courtesy of Javier Tovar  

 DECLARE WINDOW Form_1

	nCursRow := GetCursorPos()[ 1 ] - Form_1.Row  -25 
	nCursCol := GetCursorPos()[ 2 ] - Form_1.Col  -15


  IF IsWindowActive( Form_1) 
   	Form_1.&(cName).Row := nCursRow
	Form_1.&(cName).Col := nCursCol 
  ELSE
       DoMethod ("Form_1","Restore")
  ENDIF

RETURN NIL

*---------------------------------------------*
PROCEDURE MiNombre(nControl)
*---------------------------------------------*
* https://www.hmgforum.com/viewtopic.php?p=33619&hilit=arrastrar+y+soltar#p33619
*  Courtesy of Javier Tovar  

  DECLARE WINDOW Form_1

	IF nControl = 1
		cName := "Label_01"
	ELSEIF nControl = 2
		cName := "Label_02"
	ELSEIF nControl = 3
		cName := "Label_03" 
	ELSEIF nControl = 4
		cName := "Label_04"	
        ELSEIF nControl = 5
		cName := "Label_05"	
	ELSEIF nControl = 6
		cName := "Label_06"
	ELSEIF nControl = 7
		cName := "Label_07" 
	ELSEIF nControl = 8
		cName := "Label_08"	
        ELSEIF nControl = 9
		cName := "Label_09"	
	ELSEIF nControl = 10
		cName := "Label_10"
	ELSEIF nControl = 11
		cName := "Label_11" 
	ELSEIF nControl = 12
		cName := "Label_12"	
        ELSEIF nControl = 13
		cName := "Label_13"	
	ELSEIF nControl = 14
		cName := "Label_14"
	ELSEIF nControl = 15
		cName := "Label_15" 
	ELSEIF nControl = 16
		cName := "Label_16"	
*------------------------------------------------*
        ELSEIF nControl = 17
		cName := "Label_17"
	ELSEIF nControl = 18
		cName := "Label_18" 
	ELSEIF nControl = 19
		cName := "Label_19"	
        ELSEIF nControl = 20
		cName := "Label_20"	
	ELSEIF nControl = 21
		cName := "Label_21"
	ELSEIF nControl = 22
		cName := "Label_22" 
	ELSEIF nControl = 23
		cName := "Label_23"	
        ELSEIF nControl = 24
		cName := "Label_24"	
	ELSEIF nControl = 25
		cName := "Label_25"
	ELSEIF nControl = 26
		cName := "Label_26" 
	ELSEIF nControl = 27
		cName := "Label_27"	
        ELSEIF nControl = 28
		cName := "Label_28"	
	ELSEIF nControl = 29
		cName := "Label_29"
	ELSEIF nControl = 30
		cName := "Label_30" 
	ELSEIF nControl = 31
		cName := "Label_31"
        ELSEIF nControl = 32
		cName := "Label_32"
   	ENDIF
RETURN NIL

*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-


*---------------------------------------------------*
Procedure Horax1()
*---------------------------------------------------*
  nSeconds++
  IF nSeconds == 60
     nSeconds := 0
     nMinutes++
  ENDIF

  cadena1 := PADL(nMinutes, 2, "0") + ":" + PADL(nSeconds, 2, "0")

  dbCloseAll()
  SELECT 1
  USE DateTime1
  DBGoBottom() 
  dbAppend()
  REPLACE DateTime1->NAME   WITH "BLANCAS"
  REPLACE DateTime1->DIA_E  WITH  DATE()
  REPLACE DateTime1->HORA_E WITH "00:"+ cadena1 

Return Nil


*---------------------------------------------------*
Procedure Horax2()
*---------------------------------------------------*
  nSeconds++
  IF nSeconds == 60
     nSeconds := 0
     nMinutes++
  ENDIF

  cadena2 := PADL(nMinutes, 2, "0") + ":" + PADL(nSeconds, 2, "0")

  dbCloseAll()
  SELECT 2
  USE DateTime2
  DBGoBottom() 
  dbAppend()
  REPLACE DateTime2->NAME   WITH "NEGRAS"
  REPLACE DateTime2->DIA_E  WITH  DATE()
  REPLACE DateTime2->HORA_E WITH "00:"+ cadena2 

Return Nil

*---------------------------------------------------*
Function StartTimer1()
*---------------------------------------------------*

    nSeconds := 0
    nMinutes := 0

    SetProperty( "Form_1","Timer_1", "Enabled", .T.)

    Form_1.Label_Time2.VALUE := "00:00" 

    SetProperty( "Form_1","Timer_2", "Enabled", .F.)

   SetProperty( "Form_1","Button_1", "Enabled", .T.)
   SetProperty( "Form_1","Button_2", "Enabled", .T.)

   SetProperty( "Form_1","Button_3", "Enabled", .F.)
   SetProperty( "Form_1","Button_4", "Enabled", .F.)


Return NIL

*----------------------------------------------------*
Function StartTimer2()
*----------------------------------------------------*

    nSeconds := 0
    nMinutes := 0

    SetProperty("Form_1", "Timer_2", "Enabled", .T.)

    Form_1.Label_Time1.VALUE := "00:00" 

    SetProperty( "Form_1","Timer_1", "Enabled", .F.)

    SetProperty( "Form_1","Button_1", "Enabled", .F.)
    SetProperty( "Form_1","Button_2", "Enabled", .F.)
  
    SetProperty( "Form_1","Button_3", "Enabled", .T.)
    SetProperty( "Form_1","Button_4", "Enabled", .T.)

Return NIL

*----------------------------------------------------*
Function StopTimer1()
*----------------------------------------------------*
  LOCAL Busty,cl_start, cl_end, final 

    SetProperty("Form_1", "Timer_1", "Enabled", .F.)

    eXida1 := Form_1.Label_Time1.VALUE 

    // Reiniciar el contador
    nSeconds := 0
    nMinutes := 0

    SetProperty( "Form_1","Button_1", "Enabled", .F.)
    SetProperty( "Form_1","Button_2", "Enabled", .F.)

    SetProperty( "Form_1","Button_3", "Enabled", .T.)
    SetProperty( "Form_1","Button_4", "Enabled", .T.)
  
    SELECT 1
    USE DateTime1 
    DBGoBottom() 

    IF DateTime1->HORA_E == ""
       MsgStop("Falta Tiempo de Inicio","Atención")
       Return(.F.)
    ELSE
       REPLACE DateTime1->HORA_S  WITH "00:"+ eXida1   // <-- TIME()
    ENDIF

*------------------------------------------------------------*

  Busty    := DateTime1->HORA_E  
  cl_start := ALLTRIM( Busty ) 
  cl_end   := DateTime1->Hora_S   

  final := Tstring(IF(cl_end < cl_start, 86400 , 0) +;     //  <====  24 horas (86400 segundos)  Fórmula divide el valor de tiempo entre 3600 
                    Secs(cl_end) - Secs(cl_start))

*------------------------------------------------------------*
  
  SELECT 1
  DBGoBottom() 
  REPLACE DateTime1->HORA_T  WITH final 

  Form_1.xBrowse_1.refresh
  Form_1.xBrowse_1.SetFocus()

  DBCLOSEALL()

  Form_1.Label_Time1.VALUE := "00:00"

  Sumanys1()

Return NIL

*----------------------------------------------------*
Function StopTimer2()
*----------------------------------------------------*
 LOCAL Busty2,cl_start2, cl_end2, final2 

    SetProperty("Form_1", "Timer_2", "Enabled", .F.)

    eXida2 := Form_1.Label_Time2.VALUE 

    // Reiniciar el contador
    nSeconds := 0
    nMinutes := 0

    SetProperty( "Form_1","Button_1", "Enabled", .T.)
    SetProperty( "Form_1","Button_2", "Enabled", .T.)

    SetProperty( "Form_1","Button_3", "Enabled", .F.)
    SetProperty( "Form_1","Button_4", "Enabled", .F.)

  SELECT 2
  USE DateTime2 
  DBGoBottom() 

  IF DateTime2->HORA_E == ""
     MsgStop("Falta Tiempo de Inicio","Atención")
     Return(.F.)
  ELSE
     REPLACE DateTime2->HORA_S  WITH "00:"+ eXida2   //<--- TIME()
  ENDIF

*-------------------------------------------------------------------*
  Busty2    := DateTime2->HORA_E  
  cl_start2 := ALLTRIM( Busty2 ) 
  cl_end2   := DateTime2->Hora_S   

  final2 := Tstring(IF(cl_end2 < cl_start2, 86400 , 0) +;     //  <====  24 horas (86400 segundos)
                    Secs(cl_end2) - Secs(cl_start2))

*--------------------------------------------------------------------*

  SELECT 2
  DBGoBottom() 
  REPLACE DateTime2->HORA_T WITH final2 

  Form_1.xBrowse_2.refresh
  Form_1.xBrowse_2.SetFocus()

  DBCLOSEALL()

  Form_1.Label_Time2.VALUE := "00:00"

  Sumanys2()

Return Nil

*----------------------------------------------------*
Function UpdateTimer1()
*----------------------------------------------------*

    nSeconds++
    IF nSeconds == 60
        nSeconds := 0
        nMinutes++
    ENDIF

    Form_1.Label_Time1.VALUE := PADL(nMinutes, 2, "0") + ":" + PADL(nSeconds, 2, "0")

Return NIL

*----------------------------------------------------*
Function UpdateTimer2()
*----------------------------------------------------*
    nSeconds++
    IF nSeconds == 60
        nSeconds := 0
        nMinutes++
    ENDIF

    Form_1.Label_Time2.VALUE := PADL(nMinutes, 2, "0") + ":" + PADL(nSeconds, 2, "0")

Return NIL

*------------------------------------------*
FUNCTION Sumanys1()
*------------------------------------------*
LOCAL nTotal,cl_secs, aTotaly

 dbCloseAll()

 SELECT 1
 USE DateTime1
 COUNT TO nRecords

 IF nRecords == 0
    MsgStop("No hay Registros","Atención")
    Return(.F.)
 ENDIF
 
    For i = 1 to nRecords  
            SUM Secs( DateTime1->HORA_T) TO nTotal 
    Next 
  
     cl_secs := nTotal
     aTotaly :=  StrZero(INT(Mod(cl_secs/3600, 24)), 2, 0) + ":" +;
                 StrZero(INT(Mod(cl_secs/  60, 60)), 2, 0) + ":" +;
                 StrZero(INT(Mod(cl_secs     , 60)), 2, 0)

  IF IsWindowActive( Form_1) 
     Form_1.Label_TOT1.VALUE := "Blancas Total: "+ SPACE(1) + ALLTRIM( RIGHT( aTotaly ,5) )
  ENDIF

Return Nil 


*------------------------------------------*
FUNCTION Sumanys2()
*------------------------------------------*
LOCAL nTotal,cl_secs, aTotaly

 dbCloseAll()

 SELECT 1
 USE DateTime2
 COUNT TO nRecords

 IF nRecords == 0
    MsgStop("No hay Registros","Atención")
    Return(.F.)
 ENDIF

    For i = 1 to nRecords  
            SUM Secs( DateTime2->HORA_T) TO nTotal 
    Next 
  
     cl_secs := nTotal
     aTotaly :=  StrZero(INT(Mod(cl_secs/3600, 24)), 2, 0) + ":" +;
                 StrZero(INT(Mod(cl_secs/  60, 60)), 2, 0) + ":" +;
                 StrZero(INT(Mod(cl_secs     , 60)), 2, 0)

  IF IsWindowActive( Form_1) 
     Form_1.Label_TOT2.VALUE := "Negras Total:  "+ SPACE(1) + ALLTRIM( RIGHT( aTotaly ,5) )
  ENDIF

Return Nil 

*---------------------------------------------* 
 PROCEDURE SalExit()
*---------------------------------------------*

  IF MsgYesNo("Delete DataBases ?","Atención") 
     dbcloseall()
     FileDelete("DateTime*.dbf")

     Form_1.xBrowse_1.refresh
     Form_1.xBrowse_2.refresh

     IF !File("DateTime1.dbf")
               DateTime_1()
     ENDIF 
     IF !File("DateTime2.dbf")
               DateTime_2()
     ENDIF 
  ENDIF

Return Nil

*---------------------------------------------* 
 FUNCTION DateTime_1()
*---------------------------------------------* 
 LOCAL aStruct := { ;
  { "NAME"       , "C", 15, 0 }, ;
  { "DIA_E"      , "D",  8, 0 }, ;
  { "HORA_E"     , "C",  8, 0 }, ;
  { "HORA_S"     , "C",  8, 0 }, ;
  { "HORA_T"     , "C",  8, 0 }  ;
  }

  DbCreate( "DateTime1", aStruct, .T. )

Return 

*---------------------------------------------* 
 FUNCTION DateTime_2()
*---------------------------------------------* 
 LOCAL aStruct := { ;
   { "NAME"       , "C", 15, 0 }, ;
   { "DIA_E"      , "D",  8, 0 }, ;
   { "HORA_E"     , "C",  8, 0 }, ;
   { "HORA_S"     , "C",  8, 0 }, ;
   { "HORA_T"     , "C",  8, 0 }  ;
   }

  DbCreate( "DateTime2", aStruct, .T. )

Return 

*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*-_._-*



 




